对应 LeetCode 127 单词接龙

问题定义

给定一个字典序列 wordList,一个初始的单词 beginWord 和一个目标单词 endWord,现在要求每次变换满足以下条件将 beginWord 转换为 endWord:

  • 每次只能转换一个字母
  • 转换后的单词必须出现在 wordList 中

求是否能够在满足对应的转换条件的前提下,能否将 beginWord 转换成 endWord,如果可以转换,则返回转换的最少次数;如果不能转换,则返回 0

数据范围:

  • \(1 <= beginWord.length <= 10\)
  • \(endWord.length == beginWord.length\)
  • \(1 <= wordList.length <= 5000\)
  • \(wordList[i].length == beginWord.length\)
  • \(beginWord\)、\(endWord\) 和 \(wordList[i]\) 由小写英文字母组成
  • \(beginWord != endWord\)

解决思路

  • BFS

    这个问题是一个典型的 BFS 问题,只需要每次遍历时对每个单词的每个位置进行相应的转换,再进行比较即可,使用一个 Map 来记录当前的操作次数

  • 双向 BFS

    由于数据量比较大,使用一般的 BFS 的搜索方式使得导致每次的维度的节点数量爆炸式的增长,根据题意,最终的 end 需要在 wordList 中才有可能能进行转换,因此可以从 beginWord 和 endWord 两个方向出发,使得搜索的节点数大幅度减少,从而减少计算时间

  • A* 搜索

    每个转换的单词之间的相差的字母的数量可以看成是一个带有权重的边,此时这个问题就可以转换成为一般的图搜索问题,即找到一条权重最小的路径从 beinWord ——> endWord

实现

  • BFS

    class Solution {
    public int ladderLength(String beginWord, String endWord, List<String> wordList) {
    if (!wordList.contains(endWord)) return 0; Deque<String> deque = new LinkedList<>();
    Map<String, Integer> map = new HashMap<>(); // 用于记录已经访问的路径长度 deque.offer(beginWord);
    map.put(beginWord, 1); while (!deque.isEmpty()) {
    int size = deque.size(); // 每层需要遍历的节点的数量
    while (size-- > 0) {
    String node = deque.poll();
    int n = node.length();
    char[] array = node.toCharArray();
    // 转换部分。。
    for (int i = 0; i < n; ++i) {
    char ch = array[i];
    for (int j = 0; j < 26; ++j) {
    array[i] = (char) ('a' + j);
    String sub = String.valueOf(array); if (!wordList.contains(sub)) continue;
    if (map.containsKey(sub)) continue; if (sub.equals(endWord))
    return map.get(node) + 1; map.put(sub, map.get(node) + 1);
    deque.offer(sub);
    } array[i] = ch;
    }
    }
    } return 0;
    }
    }

    直接使用 BFS 的方式会导致访问的节点数量爆炸性地增长,因此这种方式会导致超时

  • 双向 BFS

    class Solution {
    private final Set<String> set = new HashSet<>(); public int ladderLength(String begin, String end, List<String> wordList) {
    if (!wordList.contains(end)) return 0; set.addAll(wordList); int ans = bfs(begin, end); return ans == -1 ? 0 : ans + 1;
    } int bfs(String begin, String end) {
    Deque<String> cur = new LinkedList<>();
    Deque<String> other = new LinkedList<>(); // 从 beiginWord 向下搜索
    Map<String, Integer> top = new HashMap<>();
    // 从 endWord 向上搜素
    Map<String, Integer> bottom = new HashMap<>(); top.put(begin, 0);
    bottom.put(end, 0); cur.offer(begin);
    other.offer(end); while (!cur.isEmpty() && !other.isEmpty()) {
    int t = -1;
    // 交替搜索,使得每次遍历的节点数是平衡的
    if (cur.size() <= other.size()) {
    t = update(cur, top, bottom);
    } else {
    t = update(other, bottom, top);
    } if (t != -1) return t;
    } return -1;
    } int update(
    Deque<String> d,
    Map<String, Integer> top,
    Map<String, Integer> bottom
    ) {
    String node = d.poll();
    int val = top.get(node); int n = node.length(); // 转换每个位置的字母,搜索满足条件的单词
    char[] array = node.toCharArray();
    for (int i = 0; i < n; ++i) {
    char ch = array[i];
    for (int j = 0; j < 26; ++j) {
    array[i] = (char) ('a' + j);
    String tmp = String.valueOf(array); if (!set.contains(tmp)) continue;
    if (top.containsKey(tmp)) continue; if (bottom.containsKey(tmp))
    return val + bottom.get(tmp) + 1; d.offer(tmp);
    top.put(tmp, val + 1);
    }
    array[i] = ch;
    } return -1;
    }
    }
  • A* 搜索

    class Solution {
    static class Node {
    String str;
    int val; Node(String _str, int _val) {
    this.str= _str;
    this.val = _val;
    }
    } String s, e;
    int INF = 0x3f3f3f3f;
    Set<String> set = new HashSet<>(); public int ladderLength(String _s, String _e, List<String> wordList) {
    this.s = _s;
    this.e = _e; this.set.addAll(wordList); int ans = aStar(); return ans == -1 ? 0 : ans + 1;
    } int aStar() {
    PriorityQueue<Node> pq = new PriorityQueue<>((a, b) -> a.val - b.val);
    Map<String, Integer> dist = new HashMap<>();
    dist.put(s, 0);
    pq.offer(new Node(s, find(s))); // 搜索边。。
    while (!pq.isEmpty()) {
    Node node = pq.poll();
    String str = node.str;
    if (str.equals(e)) break; int distance = dist.get(str);
    int n = str.length(); // 字母转换部分
    char[] array = str.toCharArray();
    for (int i = 0; i < n; ++i) {
    char ch = array[i];
    for (int j = 0; j < 26; ++j) {
    array[i] = (char) ('a' + j);
    String sub = String.valueOf(array);
    if (!set.contains(sub)) continue; if (!dist.containsKey(sub) || dist.get(sub) > distance + 1) {
    dist.put(sub, distance + 1);
    pq.offer(new Node(sub, find(sub) + dist.get(sub)));
    }
    } array[i] = ch;
    }
    } return dist.containsKey(e) ? dist.get(e) : -1;
    } int find(String str) {
    if (str.length() != e.length()) return INF;
    int n = str.length();
    int ans = 0; for (int i = 0; i < n; ++i) {
    ans += str.charAt(i) == e.charAt(i) ? 0 : 1;
    } return ans;
    }
    }

参考:

[1] https://leetcode-cn.com/problems/word-ladder/solution/gong-shui-san-xie-ru-he-shi-yong-shuang-magjd/

BFS(一)单词接龙的更多相关文章

  1. 单词接龙(dragon)(BFS)

    单词接龙(dragon) 时间限制: 1 Sec  内存限制: 64 MB提交: 12  解决: 5[提交][状态][讨论版] 题目描述 单 词接龙是一个与我们经常玩的成语接龙相类似的游戏,现在我们已 ...

  2. Leetcode之广度优先搜索(BFS)专题-127. 单词接龙(Word Ladder)

    Leetcode之广度优先搜索(BFS)专题-127. 单词接龙(Word Ladder) BFS入门详解:Leetcode之广度优先搜索(BFS)专题-429. N叉树的层序遍历(N-ary Tre ...

  3. Leetcode 126.单词接龙II

    单词接龙II 给定两个单词(beginWord 和 endWord)和一个字典 wordList,找出所有从 beginWord 到 endWord 的最短转换序列.转换需遵循如下规则: 每次转换只能 ...

  4. LeetCode 126. Word Ladder II 单词接龙 II(C++/Java)

    题目: Given two words (beginWord and endWord), and a dictionary's word list, find all shortest transfo ...

  5. Java实现 LeetCode 127 单词接龙

    127. 单词接龙 给定两个单词(beginWord 和 endWord)和一个字典,找到从 beginWord 到 endWord 的最短转换序列的长度.转换需遵循如下规则: 每次转换只能改变一个字 ...

  6. Java实现 LeetCode 126 单词接龙 II

    126. 单词接龙 II 给定两个单词(beginWord 和 endWord)和一个字典 wordList,找出所有从 beginWord 到 endWord 的最短转换序列.转换需遵循如下规则: ...

  7. NOIP2000单词接龙[DFS]

    题目描述 单词接龙是一个与我们经常玩的成语接龙相类似的游戏,现在我们已知一组单词,且给定一个开头的字母,要求出以这个字母开头的最长的“龙”(每个单词都最多在“龙”中出现两次),在两个单词相连时,其重合 ...

  8. Noip2000 T3 单词接龙

    题目描述 单词接龙是一个与我们经常玩的成语接龙相类似的游戏,现在我们已知一组单词,且给定一个开头的字母,要求出以这个字母开头的最长的“龙”(每个单词都最多在“龙”中出现两次),在两个单词相连时,其重合 ...

  9. 洛谷 P1019 单词接龙 Label:dfs

    题目描述 单词接龙是一个与我们经常玩的成语接龙相类似的游戏,现在我们已知一组单词,且给定一个开头的字母,要求出以这个字母开头的最长的“龙”(每个单词都最多在“龙”中出现两次),在两个单词相连时,其重合 ...

  10. 【wikioi】1018 单词接龙

    题目链接 算法:DFS+考你阅题 题目描述: 单词接龙是一个与我们经常玩的成语接龙相类似的游戏,现在我们已知一组单词,且给定一个开头的字母,要求出以这个字母开头的最长的“龙”(每个单词都最多在“龙”中 ...

随机推荐

  1. 有人说SaToken吃相难看,你怎么看。

    前言 今天摸鱼逛知乎,偶然看到了一个回答,8月份的,是关于SaToken的,一时好奇就点了进去. 好家伙,因为一个star的问题,提问的人抱怨了许多,我有些意外,就仔细看了下面的评论,想知道一部分人的 ...

  2. SpringBoot进阶 CommandLineRunner 初始化配置

    在Spring Boot中,CommandLineRunner接口用于在应用程序启动后执行一些特定的命令行操作.通过实现CommandLineRunner接口,您可以在Spring Boot应用程序运 ...

  3. Strimzi Kafka Bridge(桥接)实战之三:自制sdk(golang版本)

    欢迎访问我的GitHub 这里分类和汇总了欣宸的全部原创(含配套源码):https://github.com/zq2599/blog_demos 本篇概览 本文是<Strimzi Kafka B ...

  4. 使用 TensorFlow 进行机器学习

    使用 TensorFlow 进行机器学习 这是使用 TensorFlow 进行机器学习的官方代码存储库. 使用 TensorFlow(Google 最新.最好的机器学习库)开始进行机器学习. 概括 第 ...

  5. 聊聊基于Alink库的特征工程方法

    示例代码及相关内容来源于<Alink权威指南(Java版)> 独热编码 OneHotEncoder 是用于将类别型特征转换为独热编码的类.独热编码是一种常用的特征编码方式,特别适用于处理类 ...

  6. Kraft模式下Kafka脚本的使用

    Kafka集群 版本:V3.5.1 名称 Node1 Node2 Node3 IP 172.29.145.157 172.29.145.182 172.29.145.183 (1)查看Kraft集群中 ...

  7. 17.1 隐藏执行CMD命令

    本章内容涉及使用Socket API和CMD命令行工具实现本地CMD命令执行.无管道正向CMD和无管道反向CMD三种功能.执行本地CMD实现使用CreateProcess函数创建一个新的CMD进程,并 ...

  8. gcd|最大公约数|欧几里得算法|欧几里得算法证明 一文说明白

    gcd 最大公因数,也称最大公约数.最大公因子,指两个或多个整数共有约数中最大的一个.a,b的最大公约数记为 $ gcd(a,b) $ ,同样的,a,b,c的最大公约数记为 $ gcd(a,b,c) ...

  9. python 远程操作svn

    SVN操作脚本 安装模块 pip install pywinrm 脚本如下 #!/usr/bin/env python3 # coding=utf-8 # author:LJX # describe: ...

  10. 2023-11-08:用go语言,字符串哈希原理和实现 比如p = 233, 也就是课上说的选择的质数进制 “ 3 1 2 5 6 ...“ 0 1 2 3 4 hash[0] = 3 * p的0

    2023-11-08:用go语言,字符串哈希原理和实现 比如p = 233, 也就是课上说的选择的质数进制 " 3 1 2 5 6 ..." 0 1 2 3 4 hash[0] = ...